
//   GNU GENERAL PUBLIC LICENSE
//   Version 3, 29 June 2007
//
//   Copyright (C) 2009, vlad
//
//   This program is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program.  If not, see <http://www.gnu.org/licenses/>.

var convertTargets = function () {
    var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var prefAscents, prefCrags, prefSectors;
    var letterMap = new Array();
    // Map for coverting
    // Special symbols
    letterMap[' '] = ' ';
    letterMap['-'] = '-';
    letterMap['_'] = '_';
    letterMap['@'] = '@';
    letterMap[','] = ',';
    letterMap['.'] = '.';
    letterMap['!'] = '!';
    letterMap['?'] = '?';

    // Numbers
    letterMap['0'] = '0';
    letterMap['1'] = '1';
    letterMap['2'] = '2';
    letterMap['3'] = '3';
    letterMap['4'] = '4';
    letterMap['5'] = '5';
    letterMap['6'] = '6';
    letterMap['7'] = '7';
    letterMap['8'] = '8';
    letterMap['9'] = '9';
    //Cyrillic
    letterMap['\u0430'] = 'a';
    letterMap['\u0431'] = 'b';
    letterMap['\u0432'] = 'v';
    letterMap['\u0433'] = 'g';
    letterMap['\u0434'] = 'd';
    letterMap['\u0435'] = 'e';
    letterMap['\u0451'] = 'jo';
    letterMap['\u0436'] = 'zh';
    letterMap['\u0437'] = 'z';
    letterMap['\u0438'] = 'i';
    letterMap['\u0439'] = 'j';
    letterMap['\u043a'] = 'k';
    letterMap['\u043b'] = 'l';
    letterMap['\u043c'] = 'm';
    letterMap['\u043d'] = 'n';
    letterMap['\u043e'] = 'o';
    letterMap['\u043f'] = 'p';
    letterMap['\u0440'] = 'r';
    letterMap['\u0441'] = 's';
    letterMap['\u0442'] = 't';
    letterMap['\u0443'] = 'u';
    letterMap['\u0444'] = 'f';
    letterMap['\u0445'] = 'h';
    letterMap['\u0446'] = 'c';
    letterMap['\u0447'] = 'ch';
    letterMap['\u0448'] = 'sh';
    letterMap['\u0449'] = 'w';
    letterMap['\u044a'] = '#';
    letterMap['\u044b'] = 'y';
    letterMap['\u044c'] = '\'';
    letterMap['\u044d'] = 'je';
    letterMap['\u044e'] = 'ju';
    letterMap['\u044f'] = 'ja';
    letterMap['\u0410'] = 'A';
    letterMap['\u0411'] = 'B';
    letterMap['\u0412'] = 'V';
    letterMap['\u0413'] = 'G';
    letterMap['\u0414'] = 'D';
    letterMap['\u0415'] = 'E';
    letterMap['\u0401'] = 'Jo';
    letterMap['\u0416'] = 'Zh';
    letterMap['\u0417'] = 'Z';
    letterMap['\u0418'] = 'I';
    letterMap['\u0419'] = 'J';
    letterMap['\u041a'] = 'K';
    letterMap['\u041b'] = 'L';
    letterMap['\u041c'] = 'M';
    letterMap['\u041d'] = 'N';
    letterMap['\u041e'] = 'O';
    letterMap['\u041f'] = 'P';
    letterMap['\u0420'] = 'R';
    letterMap['\u0421'] = 'S';
    letterMap['\u0422'] = 'T';
    letterMap['\u0423'] = 'U';
    letterMap['\u0424'] = 'F';
    letterMap['\u0425'] = 'H';
    letterMap['\u0426'] = 'C';
    letterMap['\u0427'] = 'Ch';
    letterMap['\u0428'] = 'Sh';
    letterMap['\u0429'] = 'W';
    letterMap['\u042a'] = '##';
    letterMap['\u042b'] = 'Y';
    letterMap['\u042c'] = '\'\'';
    letterMap['\u042d'] = 'Je';
    letterMap['\u042e'] = 'Ju';
    letterMap['\u042f'] = 'Ja';
    return {
        init : function () {
            //            var appcontent = document.getElementById("appcontent");
            //            if (appcontent) {
            //                appcontent.addEventListener("DOMContentLoaded", convertTargets.onPageLoad, true);
            //            }
            //            dump("TR loaded!!");

            gBrowser.addEventListener("load", function () {
                prefAscents = prefManager.getBoolPref("extensions.translitroutes.ascents");
                prefCrags = prefManager.getBoolPref("extensions.translitroutes.crags");
                prefSectors = prefManager.getBoolPref("extensions.translitroutes.sectors");

            }, false);
        },
        onPageLoad: function(aEvent) {
            var doc = aEvent.originalTarget; // doc is document that triggered "onload" event
            // do something with the loaded page.
            // doc.location is a Location object (see below for a link).
            // You can use it to make your code executed on certain pages only.
            //var statusBar=document.getElementById('status-bar');
            var statusBar=document.getElementById('translit-routes-status-bar-icon');
            // document.getElementById("status-bar").contentDocument
            //            var childrenStatusBar = statusBar.ndStatusBar.childNodes;
            //            for (var i = 0; i < childrenStatusBar.length; i++)
            //            {
            //                if (childrenStatusBar[i].nodeName == 'statusbarpanel') {
            //                    dump("Statusbar\n");
            //                }
            //            }

            //document.getElementById("translit-routes-status-bar-icon");
            if (statusBar) {
                dump("pageLoaded: Access statusbar\n"+statusBar.getAttribute(src)+"\n");

            }
            else {
                dump("pageLoaded: Not access statusbar\n");
            }
            if(!(doc.location.href.search("8a") > -1)) {
                dump("Not a 8a");
                statusBar.setAttribute(src, "chrome://translitroutes/skin/tr-16x16-disable.png");
            }
            else {
                dump("8a.\n");
                statusBar.setAttribute(src, "chrome://translitroutes/skin/tr-16x16-enable.png");
            }
        },

        run: function () {
            var fieldsAscentsID = new Array ("ctl04_TextBoxAscentName",
                "ctl05_TextBoxAscentName", "ctl06_TextBoxAscentName",
                "ctl07_TextBoxAscentName");
            var fieldsCragsID = new Array ("ctl04_TextboxAscentCrag",
                "ctl05_TextboxAscentCrag", "ctl06_TextboxAscentCrag",
                "ctl07_TextboxAscentCrag");
            var fieldsSectorsID = new Array ("ctl04_TextboxAscentSector",
                "ctl05_TextboxAscentSector", "ctl06_TextboxAscentSector",
                "ctl07_TextboxAscentSector");
            // Get preferences
            prefAscents = prefManager.getBoolPref("extensions.translitroutes.ascents");
            prefCrags = prefManager.getBoolPref("extensions.translitroutes.crags");
            prefSectors = prefManager.getBoolPref("extensions.translitroutes.sectors");

            
            // Checking domain
            if (convertTargets.checkDomain()) {
                
                // Work with Ascents
                if (prefAscents) {
                    for (var j=0; j<fieldsAscentsID.length; j++) {
                        convertTargets.convertFunc(fieldsAscentsID[j]);
                    }
                }
                // Work with Crags
                if (prefCrags) {
                    for (j=0; j<fieldsCragsID.length; j++) {
                        convertTargets.convertFunc(fieldsCragsID[j]);
                    }
                }
                // Work with Sectors
                if (prefSectors) {
                    for (j=0; j<fieldsSectorsID.length; j++) {
                        convertTargets.convertFunc(fieldsSectorsID[j]);
                    }
                }
                
            }
        },
        convertFunc: function (name)
        {
            var frame = content.frames[2];
            var textArea = frame.document.getElementById(name);
            var romanText = "";

            // textArea exists and filled
            var lengthText = textArea.value.length;
            if (textArea && (lengthText > 0)) {
                //alert("textArea "+textArea.value);
                var workText = textArea.value;
                var aLetter = "";
                // Check roman letters
                var patRoman = /[a-z]/i;
                if (patRoman.test(workText)) {
                    dump (workText+"  contains roman letter. Passed.\n")
                }
                else {
                    // Trasfrom text
                    for (var i=0; i<lengthText; i++) {
                        aLetter = workText.substr(i, 1);
                        romanText += letterMap[aLetter];
                    //alert(romanText);
                    }
                    textArea.value = romanText;
                }
            }
        },
        prefAscentsTrigger: function () {
            var sectorBool = prefManager.getBoolPref("extensions.translitroutes.ascents");
            prefManager.setBoolPref("extensions.translitroutes.ascents", !sectorBool);
	},

        prefCragsTrigger: function () {
            var sectorBool = prefManager.getBoolPref("extensions.translitroutes.crags");
            prefManager.setBoolPref("extensions.translitroutes.crags", !sectorBool);
	},

        prefSectorsTrigger: function () {
            var sectorBool = prefManager.getBoolPref("extensions.translitroutes.sectors");
            prefManager.setBoolPref("extensions.translitroutes.sectors", !sectorBool);
	},

        checkDomain: function ()
        {
            var domainName = content.document.domain;
            var pattern8a=new RegExp("8a.nu");
            if (pattern8a.test(domainName)) {
                return true;
            }
            else  {
                alert(domainName+" is not 8a.nu!");
                return false;
            }
        }
    };
}();
window.addEventListener("load", function() {
    convertTargets.init();
}, false);
